# Copyright 2020 The TensorFlow Probability Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================
"""Statistical functions."""

from __future__ import absolute_import
from __future__ import division
from __future__ import print_function

from tensorflow_probability.python.experimental.stats.sample_stats import RunningCentralMoments
from tensorflow_probability.python.experimental.stats.sample_stats import RunningCentralMomentsState
from tensorflow_probability.python.experimental.stats.sample_stats import RunningCovariance
from tensorflow_probability.python.experimental.stats.sample_stats import RunningCovarianceState
from tensorflow_probability.python.experimental.stats.sample_stats import RunningMean
from tensorflow_probability.python.experimental.stats.sample_stats import RunningMeanState
from tensorflow_probability.python.experimental.stats.sample_stats import RunningPotentialScaleReduction
from tensorflow_probability.python.experimental.stats.sample_stats import RunningPotentialScaleReductionState
from tensorflow_probability.python.experimental.stats.sample_stats import RunningVariance


__all__ = [
    'RunningCentralMoments',
    'RunningCentralMomentsState',
    'RunningCovariance',
    'RunningCovarianceState',
    'RunningMean',
    'RunningMeanState',
    'RunningPotentialScaleReduction',
    'RunningPotentialScaleReductionState',
    'RunningVariance',
]
